#!/usr/bin/env python
# -*- coding: UTF-8 -*-

from SettingsWidgets import *
from gi.repository import Gtk

class DateFormatCheckButton(GSettingsCheckButton):
    def __init__(self, label, schema, key, dep_key):
        super(DateFormatCheckButton, self).__init__(label, schema, key, dep_key)

    def set_widget(self, widget):
        self.check_widget = widget
        self.check_widget.connect('toggled', self.on_toggled_cb)

    def on_toggled_cb(self, widget):
        if widget.get_active():
            self.set_active(False)

class Module:
    def __init__(self, content_box):
        keywords = _("time, date, calendar, format, network, sync")
        sidePage = SidePage(_("Date & Time"), "cs-date-time1", keywords, content_box, module=self)
        self.sidePage = sidePage
        self.name = "calendar"
        self.comment = _("Manage date and time settings")
        self.category = "prefs"

    def on_module_selected(self):
        if not self.loaded:
            print "Loading Calendar module"
            bg = SectionBg()
            bg.expand = True
            self.sidePage.add_widget(bg)
            vbox = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
            bg.add(vbox)

            try:
                section = Section(_("Date Settings"))
                widget = self.sidePage.content_box.c_manager.get_c_widget("datetime")
                section.add_expand(widget)
                vbox.add(section)
                vbox.add(Gtk.Separator.new(Gtk.Orientation.HORIZONTAL))
            except Exception, detail:
                print detail

            section = Section(_("Date Format"))
            
            widget = GSettingsCheckButton(_("Use 24h clock"), "org.cdos.desktop.interface", "clock-use-24h", None)
            box = Gtk.HBox()
            box.set_spacing(10)
            box.add(widget)
            
            widget = GSettingsCheckButton(_("Display the date"), "org.cdos.desktop.interface", "clock-show-date", None)
            box.add(widget)
            
            widget = GSettingsCheckButton(_("Display seconds"), "org.cdos.desktop.interface", "clock-show-seconds", None)
            box.add(widget)
            
            widget = GSettingsCheckButton(_("Display week"), "org.cdos.desktop.interface", "clock-show-week", None)
            box.add(widget)
            
            date_long_format_widget = DateFormatCheckButton(_("Use preferred date"), "org.cdos.desktop.interface", "date-use-long-format", None)
            box.add(date_long_format_widget)
            
            date_short_format_widget = DateFormatCheckButton(_("Use ISO 8601 date"), "org.cdos.desktop.interface", "date-use-short-format", None)
            box.add(date_short_format_widget)
            
            #长日期格式和短日期格式一次只能选中其中一个
            date_long_format_widget.set_widget(date_short_format_widget)
            date_short_format_widget.set_widget(date_long_format_widget)
            
            section.add(box)
            #section.add(GSettingsCheckButton(_("Use 24h clock"), "org.cdos.desktop.interface", "clock-use-24h", None))
            #section.add(GSettingsCheckButton(_("Display the date"), "org.cdos.desktop.interface", "clock-show-date", None))
            #section.add(GSettingsCheckButton(_("Display seconds"), "org.cdos.desktop.interface", "clock-show-seconds", None))        
            vbox.add(section)
